Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mozilla.javascript
Class NativeJavaClass

    java.lang.Object
      org.mozilla.javascript.NativeJavaObject
          org.mozilla.javascript.NativeJavaClass

All Implemented Interfaces:
  java.io.Serializable, Callable, Function, Scriptable, Wrapper

    public class NativeJavaClass

extends NativeJavaObject
implements Function

This class reflects Java classes into the JavaScript environment, mainly for constructors and static members. We lazily reflect properties, and currently do not guarantee that a single j.l.Class is only reflected once into the JS environment, although we should. The only known case where multiple reflections are possible occurs when a j.l.Class is wrapped as part of a method return or property access, rather than by walking the Packages/java tree.

Author:
  Mike Shaver
See Also:
  `NativeJavaArray`, `NativeJavaObject`, `NativeJavaPackage`, Serialized Form

Field Summary

Fields inherited from class org.mozilla.javascript.NativeJavaObject
`javaObject, members, parent, prototype, staticType`

Fields inherited from interface org.mozilla.javascript.Scriptable
`NOT_FOUND`

Constructor Summary
`NativeJavaClass()`
`NativeJavaClass(Scriptable scope, java.lang.Class<?> cl)`

Method Summary
`java.lang.Object` | `call(Context cx, Scriptable scope, Scriptable thisObj, java.lang.Object[] args)` Call the function.
`Scriptable` | `construct(Context cx, Scriptable scope, java.lang.Object[] args)` Call the function as a constructor.
`java.lang.Object` | `get(java.lang.String name, Scriptable start)` Get a named property from the object.
`java.lang.String` | `getClassName()` Get the name of the set of objects implemented by this Java class.
`java.lang.Class<?>` | `getClassObject()`
`java.lang.Object` | `getDefaultValue(java.lang.Class<?> hint)` Get the default value of the object with a given hint.
`java.lang.Object[]` | `getIds()` Get an array of property ids.
`boolean` | `has(java.lang.String name, Scriptable start)` Indicates whether or not a named property is defined in an object.
`boolean` | `hasInstance(Scriptable value)` Determines if prototype is a wrapped Java object and performs a Java "instanceof".
`protected void` | `initMembers()`
`void` | `put(java.lang.String name, Scriptable start, java.lang.Object value)` Sets a named property in this object.
`java.lang.String` | `toString()`

Methods inherited from class org.mozilla.javascript.NativeJavaObject
`canConvert, coerceType, delete, delete, get, getParentScope, getPrototype, has, put, setParentScope, setPrototype, unwrap, wrap`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.mozilla.javascript.Scriptable
`delete, delete, get, getParentScope, getPrototype, has, put, setParentScope, setPrototype`

Constructor Detail

### NativeJavaClass

    public NativeJavaClass()

### NativeJavaClass

    public NativeJavaClass(Scriptable scope,
                           java.lang.Class<?> cl)

Method Detail

### initMembers

    protected void initMembers()

  Overrides:
    `initMembers` in class `NativeJavaObject`

### getClassName

    public java.lang.String getClassName()

  Description copied from interface: `Scriptable`
  Get the name of the set of objects implemented by this Java class. This corresponds to the [[Class]] operation in ECMA and is used by Object.prototype.toString() in ECMA.

  See ECMA 8.6.2 and 15.2.4.2.

  Specified by:
    `getClassName` in interface `Scriptable`
  Overrides:
    `getClassName` in class `NativeJavaObject`

### has

    public boolean has(java.lang.String name,
                       Scriptable start)

  Description copied from interface: `Scriptable`
  Indicates whether or not a named property is defined in an object. Does not traverse the prototype chain.

  The property is specified by a String name as defined for the `get` method.

  Specified by:
    `has` in interface `Scriptable`
  Overrides:
    `has` in class `NativeJavaObject`
  Parameters:
    `name` - the name of the property
    `start` - the object in which the lookup began
  Returns:
    true if and only if the named property is found in the object
  See Also:
    `Scriptable.get(String, Scriptable)`, `ScriptableObject.getProperty(Scriptable, String)`

### get

    public java.lang.Object get(java.lang.String name,
                                Scriptable start)

  Description copied from interface: `Scriptable`
  Get a named property from the object. Looks property up in this object and returns the associated value if found. Returns NOT_FOUND if not found. Note that this method is not expected to traverse the prototype chain. This is different from the ECMA [[Get]] operation. Depending on the property selector, the runtime will call this method or the form of `get` that takes an integer:

  JavaScript code | Java code
  --- | ---
  a.b | a.get("b", a)
  a["foo"] | a.get("foo", a)
  a[3] | a.get(3, a)
  a["3"] | a.get(3, a)
  a[3.0] | a.get(3, a)
  a["3.0"] | a.get("3.0", a)
  a[1.1] | a.get("1.1", a)
  a[-4] | a.get(-4, a)

  The values that may be returned are limited to the following:

  - java.lang.Boolean objects
  - java.lang.String objects
  - java.lang.Number objects
  - org.mozilla.javascript.Scriptable objects
  - null
  - The value returned by Context.getUndefinedValue()
  - NOT_FOUND

  Specified by:
    `get` in interface `Scriptable`
  Overrides:
    `get` in class `NativeJavaObject`
  Parameters:
    `name` - the name of the property
    `start` - the object in which the lookup began
  Returns:
    the value of the property (may be null), or NOT_FOUND
  See Also:
    `Context.getUndefinedValue()`

### put

    public void put(java.lang.String name,
                    Scriptable start,
                    java.lang.Object value)

  Description copied from interface: `Scriptable`
  Sets a named property in this object.

  The property is specified by a string name as defined for `get`.

  The possible values that may be passed in are as defined for `get`. A class that implements this method may choose to ignore calls to set certain properties, in which case those properties are effectively read-only.

  For properties defined in a prototype chain, use `putProperty` in ScriptableObject.

  Note that if a property a is defined in the prototype p of an object o, then evaluating `o.a = 23` will cause `set` to be called on the prototype p with o as the start parameter. To preserve JavaScript semantics, it is the Scriptable object's responsibility to modify o.

  This design allows properties to be defined in prototypes and implemented in terms of getters and setters of Java values without consuming slots in each instance.

  The values that may be set are limited to the following:

  - java.lang.Boolean objects
  - java.lang.String objects
  - java.lang.Number objects
  - org.mozilla.javascript.Scriptable objects
  - null
  - The value returned by Context.getUndefinedValue()

  Arbitrary Java objects may be wrapped in a Scriptable by first calling `Context.toObject`. This allows the property of a JavaScript object to contain an arbitrary Java object as a value.

  Note that `has` will be called by the runtime first before `set` is called to determine in which object the property is defined. Note that this method is not expected to traverse the prototype chain, which is different from the ECMA [[Put]] operation.

  Specified by:
    `put` in interface `Scriptable`
  Overrides:
    `put` in class `NativeJavaObject`
  Parameters:
    `name` - the name of the property
    `start` - the object whose property is being set
    `value` - value to set the property to
  See Also:
    `Scriptable.has(String, Scriptable)`, `Scriptable.get(String, Scriptable)`, `ScriptableObject.putProperty(Scriptable, String, Object)`, `Context.toObject(Object, Scriptable)`

### getIds

    public java.lang.Object[] getIds()

  Description copied from interface: `Scriptable`
  Get an array of property ids. Not all property ids need be returned. Those properties whose ids are not returned are considered non-enumerable.

  Specified by:
    `getIds` in interface `Scriptable`
  Overrides:
    `getIds` in class `NativeJavaObject`
  Returns:
    an array of Objects. Each entry in the array is either a java.lang.String or a java.lang.Number

### getClassObject

    public java.lang.Class<?> getClassObject()

### getDefaultValue

    public java.lang.Object getDefaultValue(java.lang.Class<?> hint)

  Description copied from interface: `Scriptable`
  Get the default value of the object with a given hint. The hints are String.class for type String, Number.class for type Number, Scriptable.class for type Object, and Boolean.class for type Boolean.

  A `hint` of null means "no hint". See ECMA 8.6.2.6.

  Specified by:
    `getDefaultValue` in interface `Scriptable`
  Overrides:
    `getDefaultValue` in class `NativeJavaObject`
  Parameters:
    `hint` - the type hint
  Returns:
    the default value

### call

    public java.lang.Object call(Context cx,
                                 Scriptable scope,
                                 Scriptable thisObj,
                                 java.lang.Object[] args)

  Description copied from interface: `Function`
  Call the function. Note that the array of arguments is not guaranteed to have length greater than 0.

  Specified by:
    `call` in interface `Callable`
  Specified by:
    `call` in interface `Function`
  Parameters:
    `cx` - the current Context for this thread
    `scope` - the scope to execute the function relative to. This is set to the value returned by getParentScope() except when the function is called from a closure.
    `thisObj` - the JavaScript `this` object
    `args` - the array of arguments
  Returns:
    the result of the call

### construct

    public Scriptable construct(Context cx,
                                Scriptable scope,
                                java.lang.Object[] args)

  Description copied from interface: `Function`
  Call the function as a constructor. This method is invoked by the runtime in order to satisfy a use of the JavaScript `new` operator. This method is expected to create a new object and return it.

  Specified by:
    `construct` in interface `Function`
  Parameters:
    `cx` - the current Context for this thread
    `scope` - an enclosing scope of the caller except when the function is called from a closure.
    `args` - the array of arguments
  Returns:
    the allocated object

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### hasInstance

    public boolean hasInstance(Scriptable value)

  Determines if prototype is a wrapped Java object and performs a Java "instanceof". Exception: if value is an instance of NativeJavaClass, it isn't considered an instance of the Java class; this forestalls any name conflicts between java.lang.Class's methods and the static methods exposed by a JavaNativeClass.

  Specified by:
    `hasInstance` in interface `Scriptable`
  Overrides:
    `hasInstance` in class `NativeJavaObject`
  Parameters:
    `value` - The value that appeared on the LHS of the instanceof operator
  Returns:
    an implementation dependent value

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD